Strict
Framework brl.blitz
Import brl.max2d
Import brl.glmax2d
Import brl.random
Import brl.timer
Import brl.freetypefont

AppTitle = "Font Intro - Thunder"

Type Letter
	Const LETTERS_PER_LINE = 30
	Global list:TList = New TList
	Field s$, state, x#, y#
	Field fdstx
	Field dst_x, dst_y
	Field dist#, maxdist#, ds#, w#
	Field r,g,b
	
	Function CreateList(s$)
		list.clear
		Local x=0,y=0,ws
		For Local i = 0 Until s.length
			ws = 0
			For Local j = i Until s.length
				If s[j] <> Asc" " Then ws:+1 Else Exit
			Next
			
			If x + ws >= LETTERS_PER_LINE Then
				y :+ 1
				x = 0
			EndIf
			
			list.addlast Create(Chr(s[i]), x, y)
			x:+1
		Next
	EndFunction
	
	Function Create:Letter(s$, dx, dy)
		Local l:Letter = New Letter
		l.s = s
		l.dst_x = dx*22 + 100
		l.dst_y = dy*22 + 190
		l.fdstx = l.dst_x + Rand(-50, 50)
		l.state = 1
		l.x = -30
		l.r = Rand(15, 255)
		l.g = Rand(15, 255)
		l.b = Rand(255 - l.r - l.g, 255)
		l.y = Rand(20, GH-40)
		Return l
	EndFunction 
	
	Method update()
		Local rr = r, gg = g, bb = b
		
		Select state
		Case 1 'incoming
			x :+ 2
			SetAlpha Float(x)/fdstx 
			If x >= fdstx Then
				state=2
				If y < dst_y Then ds = 1 Else ds = -1
				dist=Sqr((dst_x-x)*(dst_x-x)+(dst_y-y)*(dst_y-y))
				maxdist=dist
				w = ATan2(y-dst_y, x-dst_x)
			EndIf
		Case 2
			x = Cos(w)*dist + dst_x
			y = Sin(w)*dist + dst_y
			rr = 255 - (255 - r)*dist/maxdist
			gg = 255 - (255 - g)*dist/maxdist
			bb = 255 - (255 - b)*dist/maxdist
			w :+ ds
			dist :- 1
			If dist < 1 Then state = 3
		Case 3
			x = dst_x
			y = dst_y
			rr = 255
			gg = 255
			bb = 255
		EndSelect
		
		SetColor rr,gg,bb
		DrawText s, x, y
		
		SetAlpha 1
	EndMethod
	
	Function updateall()
		For Local l:Letter = EachIn list
			l.update
		Next
	EndFunction
EndType


Local tim:TTimer = CreateTimer(50)
Local font:TImageFont = LoadImageFont("VeraBd.ttf", 18)
If Not font Then RuntimeError "could not load font"

Const GW = 800, GH = 600
Graphics GW, GH
SetBlend ALPHABLEND

SetImageFont font

Local text$ = "99 bottles of beer on the wall, 99 bottles of beer, take one down and pass it around"

Letter.CreateList text

Repeat
	Cls
	
	Letter.updateall
	
	Flip
	WaitTimer tim
Until AppTerminate()
End
